nz = 71;
nx = 235;
v  =readbin('vel_traveltomo_nz71_nx235.bin', nz, nx);
nnz = 2*nz-1;
nnx = 2*nx-1;
nv = zeros([nnz nnx]);
nv(1:2:nnz, 1:2:nnx) = v;

for iz = 2:2:nnz
    for ix = 2:2:nnx
        nv(iz,ix) = (nv(iz-1,ix-1)+nv(iz-1,ix+1)+nv(iz-1,ix-1)+nv(iz+1,ix+1))/4;
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ix=2:2:nnx
    nv(1, ix) = nv(1,ix-1)*0.5 + nv(1,ix+1)*0.5;
    nv(nnz,ix)= nv(nnz,ix-1)*0.5 + nv(nnz,ix+1)*0.5;
end
for iz=2:2:nnz
    nv(iz,1) = nv(iz-1,1)*0.5 + nv(iz+1,1)*0.5;
    nv(iz,nnx) = nv(iz-1,nnx)*0.5 + nv(iz+1,nnx)*0.5;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for iz=2:2:nnz
    for ix = 3:2:nnx-1
        nv(iz,ix) = (nv(iz,ix-1)+nv(iz,ix+1)+nv(iz-1,ix)+nv(iz+1,ix))/4;
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ix=2:2:nnx
    for iz = 3:2:nnz-1
        nv(iz,ix) = (nv(iz,ix-1)+nv(iz,ix+1)+nv(iz-1,ix)+nv(iz+1,ix))/4;
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imagesc(nv);
nvpath=['vel_traveltomo_nz' num2str(nnz) '_nx' num2str(nnx) '.bin'];
writebin(nvpath,nv);
