%close all;
clear all;
ns = 117;
nt = 2000;
ng = 117;
dt = 0.000125;

ntaper  = 25;
ntaper1 = 400;
df      = 1/(nt)/dt;

aa = hanning(2*ntaper);
taper = aa(1:ntaper);
nw = 15;
w  = hanning(2*ntaper1);
wd = zeros([1 2*ntaper1]);
wd = w(ntaper1+1:2*ntaper1);
wd(ntaper1+1:2*ntaper1)=w(1:ntaper1);
wd1(1:nt)=1;
wd1(nt/2-ntaper1:nt/2+ntaper1-1)=wd;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fid=fopen('source_15.bin','rb');
% temp=fread(fid,1000,'float');
% fclose(fid);
% src_tmp=temp(15:end)*2;
% 
% n=length(src_tmp);
% ricker=zeros(1,nt);
% ricker(1:n)=src_tmp;
% %ricker2=diff(ricker);
% fricker=fft(ricker);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a  = zeros(1,nt);
jj = sqrt(-1);
a(1)=1;
for i=2:nt/2;
    a(i)      = (i-1)*df*2*pi;
    a(nt-i+2) = -a(i);
end
a(1+nt/2)=nt*df*pi;

for i=1:nt
    a(i)=sqrt(jj/a(i));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1:ntaper
    a(i+1)    = a(i+1)*aa(i);
end;

for i = 1:ntaper
    a(nt+1-i) = a(nt+1-i)*aa(i);
end;
a(1)=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fricker=fricker.*a;
b = zeros(nt,1);
b(:) = [1:nt]*dt-dt;
b    = sqrt(b);
b    = b';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fid=fopen('natsrc.bin','rb');
temp=fread(fid, 2000,'float');
fclose(fid);
n = length(temp);
wave      = zeros(1,nt);
wave(1:n) = temp(:);
fw        = fft(wave);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mute = zeros(1,ng);
for ig=1:ng
    mute(ig) = 150+(ig-1)*(1700-150)/480;
end
mute = floor(mute);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% d  = fdesign.bandpass('Fst1,Fp1,Fp2,Fst2,Ast1,Ap,Ast2',1/800,1/200,0.02,0.0238,60,3,60);
% Hd = design(d,'equiripple');
mycsg = zeros([nt ng]);
dwin = zeros([ns 2*ng]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
L  = nt;
fs = 1/dt;
wf = (0:L-1)*fs/(L);
mytrace = zeros([L 1]);
specig  = 50;
Q = 28; % set the attenuation factor Q = 28
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for is = 1:ns %117:117
    file=['./OBS/wadi' num2str(is) '.bin'];
%     file = ['../example_data.bin'];
    %    fid=fopen(file,'rb');
    %    temp=fread(fid,nt*ng,'float');
    %    fclose(fid);
    %    mycsg=reshape(temp,nt,ng);
    mycsg=readbin(file, nt, ng);
    
    figure(1);
    subplot(141);
    imagesc(mycsg,[-1 1]);
    colormap(gray);
    xlabel('Distance X (m)','Color','b','FontSize',17, 'fontn', 'Times');
    ylabel('Time (s)','Color','b','FontSize',17, 'fontn', 'Times');    
    title(strcat('Original CSG', ' #', num2str(is)),'Color','b',...
          'FontSize',18, 'fontn', 'Times');
    set(gca, 'xtick',[20 50 80 110]);
    set(gca, 'xticklabel',[40 100 160 220],'XColor','b','FontSize',10, 'fontn', 'Times');
    set(gca, 'ytick',[200  800  1400  2000]);
    set(gca, 'yticklabel',[0.025 0.1 0.175 0.25],'YColor','b', 'fontn', 'Times');
    %    caxis([-3e4 3e4]);
    
    figure(2);
    subplot(211);
    plot(mycsg(:,specig));
    xlabel('Time (s)','Color','Y','FontSize',17, 'fontn', 'Times');
    ylabel('Amplitude','Color','Y','FontSize',17, 'fontn', 'Times');
    set(gca, 'xtick',[200 800 1400 2000]);
    set(gca, 'xticklabel',[0.025  0.1  0.175  0.25], 'XColor','Y','FontSize',10, 'fontn', 'Times');
    set(gca, 'ytick',[-1 -0.5 0 0.5 1]);
    set(gca, 'yticklabel',[-1 -0.5 0 0.5 1], 'YColor','Y','FontSize',10, 'fontn', 'Times');
    title(strcat('Original Trace at ig = ', num2str(specig)),'Color','Y',...
          'FontSize',18, 'fontn', 'Times');
    
    figure(1);
    subplot(142);
    mytrace(:) = mycsg(:,specig); 
    fmt        = fft(mytrace);    
    plot(wf,abs(fmt)/max(abs(fmt)));
    axis([0 200 0 1]);
    xlabel('Frequency (Hz)','Color','b','FontSize',17, 'fontn', 'Times');
    ylabel('Normalized Amplitude','Color','b','FontSize',17, 'fontn', 'Times');    
    title(strcat('Processed CSG', ' #', num2str(is), ' Spectrum at ig = 117'),'Color','b',...
          'FontSize',18, 'fontn', 'Times');
    set(gca, 'xtick',[40 80 120 160]);
    set(gca, 'xticklabel',[40 80 120 160],'XColor','b','FontSize',10, 'fontn', 'Times');
    set(gca, 'ytick',[0.2  0.4 0.6 0.8  1.0]);
    set(gca, 'yticklabel',[0.2  0.4 0.6 0.8  1.0],'YColor','b', 'fontn', 'Times');
%     hold on;
    grid on;
    
    %    for j=1:ng    
    %        mycsg(1:mute(j),j)=0.0;
    %        mycsg(mute(j)+1:mute(j)+ntaper,j) = mycsg(mute(j)+1:mute(j)+ntaper,j).*taper(:);
    %    end
    %
    %    figure(2);
    %    imagesc(mycsg);
    %    colormap(gray);
    %    caxis([-3e4 3e4]);
    %    csg2=zeros(nt,ng);
    
    %    for j=1:ng
    %        trace=zeros(1,nt);
    %        trace(:)=csg(:,j);
    %        ftrace=fft(trace);
    %        ftrace=ftrace.*a;
    %        trace=ifft(ftrace);
    %        csg2(:,j)=real(trace(:)).*b;
    %    end
    
    %    figure(2);
    %    imagesc(csg2);
    %    colormap(gray);
    %    caxis([-6e3 6e3]);
    %    csg2=zeros(nt,ng);    
    %     plane3=zeros(nt,ng);     
    for ig = 1:ng
        trace    = zeros(1,nt);
        trace(:) = mycsg(:,ig);
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        for it1 = 1:1:nt
            if( trace(it1) ~= 0 )
                break;
            end;
        end;
        dwin(is, 1+(ig-1)*2) = it1;
        
        for it2 = nt:-1:1
            if( trace(it2) ~= 0 )
                break;
            end;
        end;
        dwin(is, 2+(ig-1)*2) = it2; 
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        ftrace = fft(trace);     
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Attenuation Q correction
        for ifre = 2:length(ftrace)/2
            coeff= exp( -pi * it1 * 0.000125 * (ifre-1)*8000/length(ftrace)/Q );
            if ( ifre > 24 )
                coeff = coeff/coeff*((ifre-21)^0.8); 
            end;
            ftrace(ifre) = ftrace(ifre)/coeff;
            ftrace(length(ftrace) - ifre +2) = conj(ftrace(ifre));
        end;        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %ftrace=ftrace.*fricker.*conj(fw)./(fw.*conj(fw)+1.0e-6);        
        ftrace = ftrace.*a.*conj(fw)./(conj(fw) + 1.0e-4); % phase 3d->2d  
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%
        trace2 = real(ifft(ftrace));
        trace2 = trace2 - trace2(1800);         
        trace2(1800:nt) = 0.0;                
        trace2 = trace2.*b;          % amplitude  3d -> 2d
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         trace2 = trace2 - 0.3502; % for attenuation Q
        trace2 = trace2/max(abs(trace2));        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%
        for it = 1:nt   
            if( abs(trace2(it)) <= 2.5e-2 )
                trace2(it) = 0;
            end;
        end;
%         for it2 = nt:-1:1
%             if( trace2(it2) ~= 0 )
%                 break;
%             end;
%         end;
%         dwin(is, 2+(ig-1)*2) = it2;       
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %traces     = filter(Hd,trace2);        
        csg2(:,ig) = trace2(:);
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    csg2 = bp_filter(csg2, 0.000125, 1, 15, 70, 300);   %bandpass filter 
    for ig  = 1:ng      % normalize + re-window
        it1 = dwin(is, 1+(ig-1)*2);
        it2 = dwin(is, 2+(ig-1)*2);
        csg2(1:it1, ig) = 0.0;
        csg2(it2:nt,ig) = 0.0;
        csg2(:,ig) = csg2(:,ig)/max(abs(csg2(:,ig)));
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    figure(1);
%     subplot(132);
%     imagesc(csg2, [-1 1]);
%     colormap(gray);    
%     xlabel('Distance X (m)');
%     ylabel('Time (s)');
%     title('CSG 80 after attenuation correction');
%     
%     title(strcat('Preprocessed CSG', ' #', num2str(is)));    
%     set(gca, 'xtick',[20 50 80 110]);
%     set(gca, 'xticklabel',[40 100 160 220]);
%     set(gca, 'ytick',[200  800  1400  2000]);
%     set(gca, 'yticklabel',[0.025 0.1 0.175 0.25]);
    %%%%%%%%%%%%%
    subplot(143);
    imagesc(csg2, [-1 1]);
    colormap(gray);    
    %     title('CSG 30 after attenuation correction');
    xlabel('Distance X (m)','Color','b','FontSize',17, 'fontn', 'Times');
    ylabel('Time (s)','Color','b','FontSize',17, 'fontn', 'Times');    
    title(strcat('Processed CSG', ' #', num2str(is)),'Color','b',...
          'FontSize',18, 'fontn', 'Times');
    set(gca, 'xtick',[20 50 80 110]);
    set(gca, 'xticklabel',[40 100 160 220],'XColor','b','FontSize',10, 'fontn', 'Times');
    set(gca, 'ytick',[200  800  1400  2000]);
    set(gca, 'yticklabel',[0.025 0.1 0.175 0.25],'YColor','b', 'fontn', 'Times');
    %%%%%%%%%%%%%
    figure(2);
    subplot(212);
    plot(csg2(:, specig));  
    xlabel('Time (s)','Color','Y','FontSize',17, 'fontn', 'Times');
    ylabel('Amplitude','Color','Y','FontSize',17, 'fontn', 'Times');
    set(gca, 'xtick',[200 800 1400 2000]);
    set(gca, 'xticklabel',[0.025  0.1  0.175  0.25], 'XColor','Y','FontSize',10, 'fontn', 'Times');
    set(gca, 'ytick',[-1 -0.5 0 0.5 1]);
    set(gca, 'yticklabel',[-1 -0.5 0 0.5 1], 'YColor','Y','FontSize',10, 'fontn', 'Times');
    title(strcat('Trace after Filtering at ig = ',num2str(specig)),'Color','Y',...
          'FontSize',18, 'fontn', 'Times');    
    
    figure(1);
    subplot(144);
    mytrace(:) = csg2(:, specig); 
    fmt = fft(mytrace);
    plot(wf, abs(fmt)/max(abs(fmt)));
    axis([0 200 0 1]);    
    xlabel('Frequency (Hz)','Color','b','FontSize',17, 'fontn', 'Times');
    ylabel('Normalized Amplitude','Color','b','FontSize',17, 'fontn', 'Times');    
    title(strcat('Processed CSG', ' #', num2str(is), ' Spectrum at ig = 117'),'Color','b',...
          'FontSize',18, 'fontn', 'Times');
    set(gca, 'xtick',[40 80 120 160]);
    set(gca, 'xticklabel',[40 80 120 160],'XColor','b','FontSize',10, 'fontn', 'Times');
    set(gca, 'ytick',[0.2  0.4 0.6 0.8  1.0]);
    set(gca, 'yticklabel',[0.2  0.4 0.6 0.8  1.0],'YColor','b', 'fontn', 'Times');
%     hold on;
    grid on;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    file=['./OBS_Processed/wadi_filter', num2str(is), '.bin'];
    writebin(file, csg2);    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %    trace=plane3(:,600);
    %    ft=fft(trace);
    %    figure;
    %    plot([1:nt]*df-df,abs(ft));
    %    figure;
    %    hold on;
    %    imagesc(plane);
    %    colormap(gray);
    %    caxis([-2e6 2e6]);
    %    plot(mute);
    %    hold off
    %    xlim([1 ng]);
    %    ylim([1 nt]);
    %    set(gca,'ydir','reverse');
end;
% writebin('wadi_fil_data_window.bin',dwin);
% writebin('./OBS_for_Q/wadi_q_window.bin',dwin);